#ifndef LOADER2_H
#define LOADER2_H

#define MIN_WIN32_WINNT 0x0501 /* windows xp */

#if (!defined(_WIN32_WINNT) || _WIN32_WINNT < MIN_WIN32_WINNT)
    #undef _WIN32_WINNT
	#define _WIN32_WINNT MIN_WIN32_WINNT
#endif

#include <winsock2.h>
#include <windows.h>
#include <fcntl.h>

#define LOADER2_FD_MODE_READ _O_RDONLY
#define LOADER2_FD_MODE_WRITE 0
#define LOADER2_FD_MODE_APPEND _O_APPEND

#define LOADER2_FD_MODE_TEXT _O_TEXT
#define LOADER2_FD_MODE_BINARY 0

typedef struct {
	int fd;
	HANDLE handle;
	int mode;
} loader2_fd_t;

typedef struct {
	int fdn;
	loader2_fd_t fds[1];
} loader2_param_t;

#define loader2_param_t_size(n) (sizeof(loader2_param_t)+((n)-1)*sizeof(loader2_fd_t))

int RunProcessWithFds(char *cmd, loader2_param_t *param, int len, PROCESS_INFORMATION *pi);

#endif /* LOADER2_H */
